import java.io.IOException;

public class CVPacket {

	public static final int DIRECTION_LOCATION = 1;
	public static final int TIME_START = 4;
	public static final int TIME_END = 18;

	int iDirection;
	PacketTime ptTime;
	int iPacketSize;  //change to packetsize
	String strDestinationIP;
	String strSenderIP;

    /**
     **************************************************
     *
     *
     */
     public double getTime() {
		 return ptTime.totalTime;
	 }//end getTime
    /**
     **************************************************
     *
     *
     */
     public int getPacketSize() {
		 return iPacketSize;
	 }
    /**
     **************************************************
     *
     *
     */
     public String getSenderIP() {
		 return strSenderIP;
	 }//end getSenderIP

    /**
     **************************************************
     *
     *
     */
     public String getDestinationIP() {
		return strDestinationIP;
	 }//end getSenderIP

    /**
     **************************************************
     *
     *
     */
     public static String getStatistics(CVPacket[] cvpaPacketList) {

		 StringBuffer strbReturn = new StringBuffer();

		 long lTotalSize = 0;
		 int i;

		 for(i=0;i<cvpaPacketList.length;i++)
		 	lTotalSize = lTotalSize + cvpaPacketList[i].iPacketSize;

		 return strbReturn.toString();

	 }//end getStatistics(CVPacket[])

    /**
     **************************************************
     *
     *
     */
	public CVPacket(String strCVString) throws IOException {

		Integer intTemp;
		String strTemp;

		if( !(strCVString.startsWith("#")) && !(strCVString.endsWith("#")) )
			throw new IOException("Not a Commview packet.");
		intTemp = new Integer(strCVString.substring(DIRECTION_LOCATION,DIRECTION_LOCATION+1));
		iDirection = intTemp.intValue();

		ptTime = computeTime(strCVString.substring(TIME_START, TIME_END));
		strSenderIP = parseIP(strCVString.substring(72,80));
		strDestinationIP = parseIP(strCVString.substring(80,88));
		strTemp = strCVString.substring( 104, (strCVString.length()-1) );
		iPacketSize = strCVString.length()-TIME_END-1;

	}//end CVPacket(String)

    /**
     **************************************************
     *
     *
     */
	protected PacketTime computeTime(String strTime) throws IOException {

		int iHour;
		int iMinute;
		int iSecond;
		int iMillisecond;
		PacketTime ptTemp;

		iMinute = Integer.parseInt(strTime.substring(0,2),16);
		iHour = Integer.parseInt(strTime.substring(4,6),16);
		iMillisecond = Integer.parseInt(strTime.substring(6,10),16);
		iSecond = Integer.parseInt(strTime.substring(12,14),16);
		ptTemp = new PacketTime(iHour,iMinute,iSecond,iMillisecond);

		return ptTemp;
	}//end computeTime(String)

    /**
     **************************************************
     *
     *
     */
	public int compare(CVPacket cvpOther) {
		return ptTime.compare(cvpOther.ptTime);

	}//end compare(CVPacket)

    /**
     **************************************************
     *
     *
     */
     public String parseIP(String strNumericIP) {

		 StringBuffer stbReturn = new StringBuffer();
		 int i;

		 for(i=0;i<strNumericIP.length();i=i+2) {
			 stbReturn.append(Integer.parseInt(strNumericIP.substring(i,i+2),16)+".");
		 }
		 return stbReturn.substring(0,stbReturn.length()-1);
	 }

    /**
     **************************************************
     **************************************************
     *
     *
     */
	class PacketTime {

		int iHour;
		int iMinute;
		int iSecond;
		double iMillisecond;
		double totalTime;

	    /**
	     **************************************************
	     *
	     *
    	 */
		PacketTime(int Hour, int Minute, int Second, int Milli) {
			iHour = Hour*60*60;
			iMinute = Minute*60;
			iSecond = Second;
			iMillisecond = .001*Milli;
			totalTime = iMillisecond+
						iSecond+
						iMinute+
						iHour;

		}//end PacketTime(int,int,int,int)

	    /**
     	 **************************************************
    	 *
    	 *
    	 */
		int compare(PacketTime ptOther) {

			if(this.totalTime>ptOther.totalTime)
				return 1;
			else if(this.totalTime==ptOther.totalTime)
					return 0;
				 else return -1;
		}//end compare(PacketTime)
	}//end PacketTime

}//end CVPacket


