import java.awt.Color;
import java.util.Vector;

public class CVPacketList {

	CVPacket[] cvpaPackets;
	double dMeanSize;
	double dStdDevSize;
	double dVariance;
	double dTimeElapsed;
	double dBytePerSec;
	int iSmallestPacket;
	int iLargestPacket;
	String strThisIPAddr;

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public CVPacketList(CVPacket[] cvpaSearchList, boolean bSender, String strIPAddr) {

		Vector vecPacketList = new Vector();
		CVPacket cvCurPacket;
		int i;

		strThisIPAddr = strIPAddr;
		for(i=0;i<cvpaSearchList.length;i++) {
			cvCurPacket = cvpaSearchList[i];
			if(bSender) {
				if(strIPAddr.equals(cvCurPacket.getSenderIP()))
						vecPacketList.addElement(cvCurPacket);
			} else if(strIPAddr.equals(cvCurPacket.getDestinationIP()))
						vecPacketList.addElement(cvCurPacket);
		}//end for
		init(vecPacketList);

	}//end CVIPAddr(Vector)

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public void init(Vector vecPacketList) {
		CVPacket cvCurPacket,cvFirstPacket;
		int iTotalSize=0;
		int i;

		sort(vecPacketList);

		cvFirstPacket = (CVPacket)vecPacketList.elementAt(0);
		cvCurPacket = (CVPacket)vecPacketList.elementAt(vecPacketList.size()-1);
		dTimeElapsed = cvCurPacket.getTime()-cvFirstPacket.getTime();
		iSmallestPacket = cvFirstPacket.getPacketSize();
		iLargestPacket = iSmallestPacket;

		for(i=0;i<vecPacketList.size();i++) {
			cvCurPacket = (CVPacket)vecPacketList.elementAt(i);
			iTotalSize +=  cvCurPacket.getPacketSize();
			if(cvCurPacket.getPacketSize()>iLargestPacket)
				iLargestPacket = cvCurPacket.getPacketSize();
			if(cvCurPacket.getPacketSize()<iSmallestPacket)
				iSmallestPacket = cvCurPacket.getPacketSize();
		}//end for

		dMeanSize = iTotalSize/vecPacketList.size();
		dVariance = 0;
		for(i=0;i<vecPacketList.size();i++) {
			cvCurPacket = (CVPacket)vecPacketList.elementAt(i);
			dVariance = dVariance +
						(dMeanSize-cvCurPacket.getPacketSize()) * (dMeanSize-cvCurPacket.getPacketSize());
		}//end for
		dVariance = dVariance/vecPacketList.size();
		dStdDevSize = Math.sqrt(dVariance);
		dBytePerSec = iTotalSize/dTimeElapsed;
		cvpaPackets = new CVPacket[vecPacketList.size()];
		for(i=0;i<vecPacketList.size();i++) {
			cvpaPackets[i] = (CVPacket)vecPacketList.elementAt(i);
		}//end for
	}//end init

	/**
	 ***********************************************************************
	 *
	 * I'm lazy so this is a bubble sort
	 */
	private void sort(Vector vecList) {

		CVPacket cvCurLoc;
		CVPacket cvCompare;
		int i,j;

		for(i=0;i<vecList.size();i++) {
			cvCurLoc = (CVPacket)vecList.elementAt(i);
			for(j=i;j<vecList.size();j++) {
				cvCompare = (CVPacket)vecList.elementAt(j);
				if(cvCompare.compare(cvCurLoc)<0) {
					vecList.setElementAt(cvCompare,i);
					vecList.setElementAt(cvCurLoc,j);
					cvCurLoc = cvCompare;
				}//end if
			}//end for
		}//end for
	}//end sort(Vector)

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public int getTotalNum() {
		return cvpaPackets.length;
	}//end getTotalNum

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public String getIP() {
		return strThisIPAddr;
	}//end getIP

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public CVPacket[] getSentList() {
		return cvpaPackets;
	}//end getSentList()

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public double getMeanSize() {
		return dMeanSize;
	}//end getMeanSize()

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public double getSizeStdDev() {
		return dStdDevSize;
	}//end getSizeStdDev

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public int getSmallPacket() {
		return iSmallestPacket;
	}//end getLargePacket

	/**
	 ***********************************************************************
	 *
	 *
	 */
	public int getLargePacket() {
		return iLargestPacket;
	}//end getLargePacket
}//end CVIPAddr