import java.util.Vector;
import org.faceless.graph.*;
import org.faceless.graph.math.*;
import org.faceless.graph.formatter.*;
import org.faceless.graph.output.*;
import java.awt.Image;
import java.io.*; // just for testing, can be removed later

public class Grapher
{
	public LineGraph myGraph = null;

	/**
	  *
	  */

	public Grapher()
	{
		myGraph = new LineGraph();
	}

	/**
	  * Call this method to add a new set of points and a corresponding line to the graph.
	  * Successive calls will simply add more lines.
	  */

	public void addCurve(CVPacket[] packetData, String targetIP, String title, java.awt.Color color)
	{
		DataCurve data = new DataCurve();
System.out.println("packetData:"+packetData.length);
			for(int i = 0; i < packetData.length; i++)
			{
				data.set(packetData[i].ptTime.totalTime,packetData[i].getPacketSize());
			}//for
myGraph.setCurveMarker(title, LineGraph.MARKER_SQUARE);
		myGraph.setCurve(title, data, color);
	}//addCurve

	/**
	  * This method returns the graph as a java.awt.Image
	  * Note that xSize and ySize refer to the size of the Image, and not the range of the graph.
	  */

	public Image renderGraph(String title, int xSize, int ySize) throws IOException
	{
		myGraph.optionTitle(title);
		ImageOutput out = new ImageOutput(xSize,ySize);

		out.render(myGraph);

		return out.getImage();
	}

	/**
	  *
	  */

	public void clearGraph()
	{
		myGraph = new LineGraph();
	}



/*	public static void main(String[] args) throws IOException
	{
		FileOutputStream out = new FileOutputStream("c:\\windows\\desktop\\test.gif");
		GIFOutput gif = new GIFOutput(600, 600, out);
		gif.render(gif.myGraph);
	}*/
}